/*---------------------------------------------
  DynamixelvgRŊO@Rg[
  ---------------------------------------------*/
/*
  UD3_SET_DXPACKETMODE (dxHost) Ƃ邱ƂCN1(RS485)DynamixelvgR
  gđDynamixelƒʐMsB

  ̊RS485ȊO̒ʐM|[g̓R\[̖ړIŎgpłB
*/
#include <us.h>
#include <ud3.h>
#include <math.h>

#define _TIMEOUT    10

#define _ADDRESS_LED                25
#define _ADDRESS_GOAL_POSITION      30
#define _ADDRESS_PRESENT_POSITION   36

short pos, goal;
int txcnt = 0, txerr = 0, rxcnt = 0, rxerr = 0;

//---------------------------------------------------------------------------------
// C
//---------------------------------------------------------------------------------
void main (void) {
  uint8_t id;
  uint16_t err;

  UD3_WAIT (2000);

  // DynamixelvgR̃zXgJn
  // ȌNCAgyуR\[ƂRS485͎gpłȂ
  UD3_SET_DXPACKETMODE (dxHost);

  DX_ChangeBaudrate (1000000); 
  if (DX_Ping (1, 1000, &err)) UD3_PUTS ("\n[PING] ID:1 Found"); else UD3_PUTS ("\n[PING] ID:1 Not Found");
  if (DX_Ping2 (&id, 1000, &err)) UD3_PRINTF ("\n[PING2] ID:%d Found\n", id);  else UD3_PRINTF ("\n[PING2] ANY ID Not Found\n");

  UD3_ACTIVE_TASK (1);
  UD3_ACTIVE_TASK (2);
  UD3_ACTIVE_TASK (3);

  uint8_t led = 0;
  uint8_t para[4];
  bool oldpb1 = UD3_GET_PUSHBUTTON1 (), oldpb2 = UD3_GET_PUSHBUTTON2 ();

  while (1) {
    UD3_SET_LED (led ^= 1);
    UD3_PRINTF ("\rGOALPOS=%4d (%5d/%5d) PRESENTPOS=%4d (%5d/%5d) DIFF=%5d", goal, txerr, txcnt, pos, rxerr, rxcnt, goal - pos);

    // RvCAXύX
    if (!oldpb1 && UD3_GET_PUSHBUTTON1 ()) {
      para[0] = para[1] = 1;
      para[2] = para[3] = 16;
      DX_WriteBlockData (1, 26, para, 4, _TIMEOUT, &err);
      UD3_PRINTF ("\nHard\n");
    }
    if (!oldpb2 && UD3_GET_PUSHBUTTON2 ()) {
      para[0] = para[1] = 15;
      para[2] = para[3] = 250;
      DX_WriteBlockData (1, 26, para, 4, _TIMEOUT, &err);
      UD3_PRINTF ("\nLoose\n");
    }
    oldpb1 = UD3_GET_PUSHBUTTON1 (), oldpb2 = UD3_GET_PUSHBUTTON2 ();

    UD3_WAIT (50);
  }
}

//---------------------------------------------------------------------------------
// ^XN1
//---------------------------------------------------------------------------------
// DynamixelGOAL POSITIONsinggplōXV^XN
UD3_TASK1 () {
  uint8_t par[] = {
    _ADDRESS_GOAL_POSITION, // address
    2,  // size

    1,  // id
    0,  //  data1
    0,  //  data2

    2,  // id
    0,  //  data3
    0   //  data4
  };
  uint16_t err;

  while (1) {
    goal = sin (UD3_GET_ELAPSEDTIME () / 1000.0) * 511.5 + 511.5;
    txcnt++;
#if 0
    if (!DX_WriteWordData (1, _ADDRESS_GOAL_POSITION, goal, _TIMEOUT, &err)) txerr++;
#else
    par[3] = par[6] = goal & 0xff;
    par[4] = par[7] = (goal >> 8) & 0xff;
    if (!DX_SyncWriteData (sizeof(par), par, &err)) txerr++;
#endif
    UD3_WAIT (5);
  }
}

//---------------------------------------------------------------------------------
// ^XN2
//---------------------------------------------------------------------------------
// DynamixelPRESENT POSITION擾^XN
UD3_TASK2 () {
  uint16_t p;
  uint16_t err;

  while (1) {
    rxcnt++;
    if (DX_ReadWordData (1, _ADDRESS_PRESENT_POSITION, &p, _TIMEOUT, &err)) pos = p;
    else rxerr++;
    UD3_WAIT (10);
  }
}

//---------------------------------------------------------------------------------
// ^XN3
//---------------------------------------------------------------------------------
// DynamixelLED_ł^XN
UD3_TASK3 () {
  uint8_t led = 0;
  uint16_t err;

  while (1) {
    txcnt++;
    if (!DX_WriteByteData (1, _ADDRESS_LED, led, _TIMEOUT, &err)) txerr++;
    led ^= 1;
    UD3_WAIT (200);
  }
}
