/*---------------------------------------------
  pTv
  ---------------------------------------------*/
/*
  ZT(ZTx3EyUZTx2)̓͂ɉĂȂɔēB
  ~MɂΉB
  ZTɉ}bvIɍsB
*/

#include <ud3.h>

// Ԓ`
#define turn_back_wait 500  // БyUm̌i
#define turn_turn_wait 500  // БyUm̐񎞊
#define back_back_wait 600  // yUm̌i
#define back_turn_wait 600  // yUm̐񎞊

#define L_DOHYO ((~UD3_GET_GPIOINPUT ()) & 0x01)  // yUoZT GPIO0 (̃}N͖gp)
#define R_DOHYO ((~UD3_GET_GPIOINPUT ()) & 0x02)  // EyUoZT GPIO1 (̃}N͖gp)

#define L_800mm ((~UD3_GET_GPIOINPUT ()) & 0x04)  // ̌oZT GPIO2 (̃}N͖gp)
#define F_800mm ((~UD3_GET_GPIOINPUT ()) & 0x08)  // ̌oZT GPIO3 (̃}N͖gp)
#define R_800mm ((~UD3_GET_GPIOINPUT ()) & 0x10)  // ĚoZT GPIO4 (̃}N͖gp)

#define EMGSTOP ((~UD3_GET_GPIOINPUT ()) & 0x400) // ~M(LOWANeBu) GPIO10

// ZT̔ɉe֐̌^錾
typedef void (*TActionFunc)(void);

bool  gSearchFlag = false;  // ̋ς邽߂̃tO(XV͓yUZT)

#define POWERGAIN 30        // o͂𒲐邽߂̃QC 0`100%Ŏw

//------------------------------------------------
//  [^[p֐
//------------------------------------------------
// ]𐮂邽߂̃[`
//  E[^(r_m2),[^(l_m1)ɃvX̒lđOi΂̂܂܂OK
//  t]Ȃ畄Ăׂ݂
void MOTOR (int16_t l_m2, int16_t r_m1) {
  r_m1 = (r_m1 * POWERGAIN) / 100;
  l_m2 = (l_m2 * POWERGAIN) / 100;

  UD3_SET_DUTY (
    -r_m1,    // E[^ւ̎wߒl
     l_m2     // [^ւ̎wߒl
  );
}

// Oi
void forward (int16_t pow) {
  MOTOR (abs(pow), abs(pow));
}

// 
void back (int16_t pow) {
  MOTOR (-abs(pow), -abs(pow));
}

// ~
void stop (void) {
  MOTOR (0, 0);
}

// MnE
void right_turn (int16_t pow) {
  MOTOR (abs(pow), -abs(pow));
}

// Mn
void left_turn (int16_t pow) {
  MOTOR (-abs(pow), abs(pow));
}

// EJ[u
void turn (int16_t l_pow, int16_t r_pow) {
  MOTOR (abs(l_pow), abs(r_pow));
}

// ԂɂMnE
void right_turn_time (uint32_t t) {
  right_turn (1000);
  UD3_WAIT (t);
  stop ();
}

// ԂɂMn
void left_turn_time (uint32_t t) {
  left_turn (1000);
  UD3_WAIT (t);
  stop ();
}

// Ԃɂi
void back_time (uint32_t t) {
  back (1000);
  UD3_WAIT (t);
  stop ();
}

//------------------------------------------------
//  {֐
//------------------------------------------------
// EyUZT̗E
void action_r_line (void) {
  UD3_SET_BUZZER (50, 80);
  back_time (turn_back_wait);       // 
  left_turn_time (turn_turn_wait);  // 
  gSearchFlag = !gSearchFlag;       // ̃J[uύX
}

// yUZT̗E
void action_l_line (void) {
  UD3_SET_BUZZER (50, 80);
  back_time (turn_back_wait);       // 
  right_turn_time (turn_turn_wait); // E
  gSearchFlag = !gSearchFlag;       // ̃J[uύX
}

// yUZT̗E
void action_rl_line (void) {
  UD3_SET_BUZZER (50, 80);
  back_time (back_back_wait);       // 
  left_turn_time (back_turn_wait);  // 
  gSearchFlag = !gSearchFlag;       // ̃J[uύX
}

// EZT̂ݔ    E]
void action_right_turn (void) {
  right_turn (1000);
}

// ʃZT̂ݔ  Oi
void action_straight (void) {
  forward (1000);
}

// EEʃZT  EɑOi
void action_right_curve (void) {
  turn (800, 500);
}

// ZT        
void action_left_turn (void) {
  left_turn (1000);
}

// EʃZT  ɑOi
void action_left_curve (void) {
  turn (500, 800);
}

// 𑕂
void action_search (void) {
  if (gSearchFlag)  turn (500, 800);
  else              turn (800, 500);
}

// (O̔֐I̓p)
void dummy (void) {}

//------------------------------------------------
// ZTɂ铮p^[
//   SZT̊K敪p^[
//------------------------------------------------
const TActionFunc gActTable[32] = {
  // RML_RL
  // 000 00 ZT
  action_search,
  // 000 01
  action_l_line,
  // 000 10
  action_r_line,
  // 000 11
  action_rl_line,

  // RML_RL
  // 001 00 ZT
  action_left_turn,
  // 001 01
  action_l_line,
  // 001 10
  action_r_line,
  // 001 11
  action_rl_line,

  // RML_RL
  // 010 00 ZT
  action_straight,
  // 010 01
  action_l_line,
  // 010 10
  action_r_line,
  // 010 11
  action_rl_line,

  // RML_RL
  // 011 00 EZT
  action_left_curve,
  // 011 01
  action_l_line,
  // 011 10
  action_r_line,
  // 011 11
  action_rl_line,

  // RML_RL
  // 100 00 EZT
  action_right_turn,
  // 100 01
  action_l_line,
  // 100 10
  action_r_line,
  // 100 11
  action_rl_line,

  // RML_RL
  // 101 00 EEZT
  action_straight,
  // 101 01
  action_l_line,
  // 101 10
  action_r_line,
  // 101 11
  action_rl_line,

  // RML_RL
  // 110 00 EEZT
  action_right_curve,
  // 110 01
  action_l_line,
  // 110 10
  action_r_line,
  // 110 11
  action_rl_line,

  // RML_RL
  // 111 00 EEEZT
  action_straight,
  // 111 01
  action_l_line,
  // 111 10
  action_r_line,
  // 111 11
  action_rl_line
};

//---------------------------------------------------------------------------------
// 킢^XN
//---------------------------------------------------------------------------------
UD3_TASK1 () {
  int  val;
  int  i = 0;
  char led = 0;

  UD3_SET_BUZZER (20, 10);
  UD3_WAIT (100);
  UD3_SET_BUZZER (30, 10);

  // PB1ȂPB2܂ő҂
  while (1) {
    if ((i++ % 50) == 0) UD3_SET_LED (led = !led);
    if (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()) break;
    UD3_WAIT (10);
  }
  UD3_WAIT (10);

  // PB1ȂPB2܂ő҂
  while (1) {
    if ((i++ % 10) == 0) {
      UD3_SET_LED (led = !led);
      UD3_SET_BUZZER (60, 5);
    }
    if (!(UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ())) break;
    UD3_WAIT (5);
  }

  UD3_SET_LED (1);

  UD3_WAIT (1000);
  UD3_SET_BUZZER (15, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (15, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (20, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (20, 20);
  UD3_WAIT (1000);
  UD3_SET_BUZZER (32, 70);

  // [^쓮
  UD3_SET_MOTORENABLE (true);

  // p^[KvȂ炱ɂłLq
  switch (UD3_GET_DIPSWICH ()) {
    case 0:
      break;
    case 1:
      break;
    case 2:
      break;
    case 3:
      break;
    case 4: // Kȗ
      left_turn_time (500);
      right_turn (1000);
      break;
  }

  while (1) {
    // 5̃ZT̒lɂ菈֐I
    //  ZT̐̂ŁAgActTablee[û͉
    //  ̑SẴp^[ɉ}bv肳΁AȃZT̔
    //  NĂΉł\Ȃ
    val = ~UD3_GET_GPIOINPUT ();
    gActTable[(val & 0x1f)]();
  }
}

//---------------------------------------------------------------------------------
// ~Ď^XN
//---------------------------------------------------------------------------------
UD3_TASK2 () {
  while (1) {
    // [^Cl[uԂňȉ̏ꂩoƒ~
    //   GPIO10LOWM
    //   PB1ȂPB20.2bȏ㉟
    if (UD3_GET_MOTORENABLE () && (EMGSTOP || (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()))) {
      UD3_WAIT (200);
      // 0.2bɂxMmF(댟m΍)
      if (UD3_GET_MOTORENABLE () && (EMGSTOP || (UD3_GET_PUSHBUTTON1 () || UD3_GET_PUSHBUTTON2 ()))) {
        while (1) {
          // [^쓮~
          UD3_SET_MOTORENABLE (false);
          UD3_SET_BUZZER (50, 20);

          UD3_SET_LED (1);
          UD3_WAIT (250);

          UD3_SET_LED (0);
          UD3_WAIT (250);
        }
      }
    }
    UD3_WAIT (10);
  }
}

//---------------------------------------------------------------------------------
// C
//---------------------------------------------------------------------------------
// ZT̐MGPIO0`4,10Ŏ荞ނ߂̏ƁA[^̋쓮ݒB
// 肵쓮]ޏꍇ̓v֐̌zƗǂB
//---------------------------------------------------------------------------------
void main (void) {
  UD3_CFG_GPIO0 (GPIO_IN_PULLUP_ON);  // yUpZT[
  UD3_CFG_GPIO1 (GPIO_IN_PULLUP_ON);  // yUpZT[E
  UD3_CFG_GPIO2 (GPIO_IN_PULLUP_ON);  // ΕZT[
  UD3_CFG_GPIO3 (GPIO_IN_PULLUP_ON);  // ΕZT[
  UD3_CFG_GPIO4 (GPIO_IN_PULLUP_ON);  // ΕZT[E
  UD3_CFG_GPIO10 (GPIO_IN_PULLUP_ON); // ً}~

  // PWMg80kHz
  UD3_SET_M1FREQUENCY (80);
  UD3_SET_M2FREQUENCY (80);
  // PWMő吧93%(100%-7%)
  // tp[ɕsȋꍇ͂̒l傫
  UD3_SET_M1RECHARGE (7);
  UD3_SET_M2RECHARGE (7);
  // 쓮[hݒ
  UD3_SET_M1DRIVEMODE (_UD_MOTOR_DRIVE);
  UD3_SET_M2DRIVEMODE (_UD_MOTOR_DRIVE);
  // [^̉]w
  //   [^̍EM1,M2̑Ή̓P[u̓ւ
  //   t̉]݈̂ȉ̊֐őΉ
  //    0:M1,M2ƂftHg
  //    1:M1̂ݔ]
  //    2:M2̂ݔ]
  //    3:M1,M2ɔ]
  UD3_SET_MOTORREVRSE (0);
  // vo͂̌z50/ms
  UD3_SET_MOTORRAMP (50);

  // ^XN1,2N
  UD3_ACTIVE_TASK (1);
  UD3_ACTIVE_TASK (2);
}
